// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "PegApp.hh"
#include "PegEditMenu.hh"

using namespace std;

PegEditMenu::PegEditMenu()
{
   base_w = gtk_menu_item_new_with_mnemonic("_Edit");

   menu = gtk_menu_new();

   menuPrefs = gtk_menu_item_new_with_mnemonic("_Preferences");
   gtk_menu_shell_insert(GTK_MENU_SHELL(menu), menuPrefs, 0);

   g_signal_connect_swapped (G_OBJECT (menuPrefs), "activate",
                             G_CALLBACK (preferences_cb),
                             (gpointer) NULL);

   gtk_menu_item_set_submenu (GTK_MENU_ITEM(base_w), menu);

   GtkTooltips *tips = theApp->get_tips_group();
   if (tips)  gtk_tooltips_set_tip(tips, menuPrefs, "Edit user preferences",NULL);
}

PegEditMenu::~PegEditMenu()
{
   
}

int PegEditMenu::show()
{
   gtk_widget_show(menuPrefs);
   gtk_widget_show(base_w); 
   return 0; 
}

int PegEditMenu::preferences_cb()
{
   theApp->launch_preferences_dialog(); 
   return 1; 
}






