// 
//  Copyright (C) 2002,2007-8  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGFLOATINGMENU_HH
#define PEGFLOATINGMENU_HH

#include <gtk/gtk.h>

class PegParEntry;

class PegFloatingMenu 
{
  public:
    PegFloatingMenu(PegParEntry *entry);
    virtual ~PegFloatingMenu();
    virtual const char *const className() { return ("PegFloatingMenu"); }

    GtkWidget* get_menu()    { return _menu; }

    static int  indirection_cb(GObject *object, gpointer user_data);
    static int  restore_init_value_cb(GObject *object, gpointer user_data);
    static int  display_init_value_cb(GObject *object, gpointer user_data);
    static int  display_mode_cb(GObject *object, gpointer user_data);
    static int  display_type_cb(GObject *object, gpointer user_data);
    static int  display_min_cb(GObject *object, gpointer user_data);
    static int  display_max_cb(GObject *object, gpointer user_data);
    static int  display_prompt_cb(GObject *object, gpointer user_data);
    static int  browse_file_cb(GObject *object, gpointer user_data);
    static int  set_to_min_cb(GObject *object, gpointer user_data);
    static int  set_to_max_cb(GObject *object, gpointer user_data);
    static int  param_help_cb(GObject *object, gpointer user_data);

  protected:
    PegParEntry* _entry; 
    GtkWidget* _menu; 
    GtkWidget* _menuIndir;
    GtkWidget* _menuRestore;
    GtkWidget* _menuMin;
    GtkWidget* _menuMax;
    GtkWidget* _menuDisplay;
    GtkWidget* _submenuDisplay;
    GtkWidget* _menuSubDisp[6];
    GtkWidget* _menuHelp;
    GtkWidget* _menuBrowse;
    GtkWidget*  _pulldown; 
};

#endif
