// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGHELPMENU_HH
#define PEGHELPMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

using namespace std;

class PegHelpMenu
{
  public:
    PegHelpMenu();
    virtual ~PegHelpMenu();

    static int reference_manual_cb();
    static int hints_cb(gpointer user_data);
    static int faq_cb();
    static int about_cb();
    static int acknowledgement_cb();
    static int current_tool_cb(); 

    void enable_tool_help()
       { if (menuTool) gtk_widget_set_sensitive(GTK_WIDGET(menuTool), true); } 
    void disable_tool_help() 
       { if (menuTool) gtk_widget_set_sensitive(GTK_WIDGET(menuTool), false); }

    virtual int show();

    GtkWidget*  base_widget()   { return base_w; }

  protected:
    GtkWidget *menu;
    GtkWidget *menuRef;
    GtkWidget *menuHints;
    GtkWidget *subHints;
    GtkWidget *subHintsIface;
    GtkWidget *subHintsPfiles;
    GtkWidget *subHintsPrefs;
    GtkWidget *menuFaq;
    GtkWidget *menuAbout;
    GtkWidget *menuAck;
    GtkWidget *menuTool;
    GtkWidget *sep; 
    GtkWidget *base_w; 
};

#endif 
