// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGMENU_HH
#define PEGMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

using namespace std;

class PegFileMenu;
class PegEditMenu;
class PegHelpMenu;
class CiaoAnalysisMenu;

class PegMenu
{
  public:
    PegMenu(string filename="", GtkTooltips* tips=NULL);
    ~PegMenu();

    int update_filelist(string fname); 
    int show(); 
    GtkWidget*  base_widget()  { return base_w; }

    void enable_help_current_tool(bool val);  

  protected:
    GtkWidget* base_w;
    PegFileMenu  *menuFile;
    PegEditMenu  *menuEdit;
    PegHelpMenu  *menuHelp;
    CiaoAnalysisMenu *menuAnalysis; 
};

#endif 
