// 
//  Copyright (C) 2002,2007,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGPARDATA_HH
#define PEGPARDATA_HH

class PegParEntry; 
class Parameter;

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string>
#include <list>


class PegParData {

  public:

    PegParData(string fname, int argc, const char **argv, GtkWidget* parent);
    ~PegParData();

    void Setup();
    int  Validate(); 
    int  Write(char *fname=NULL, int overwrite=0); 
    int  ChangesMade(); 


    int  SetParamValue(string pname, string value);
    string  GetParamValue(string pname);

    list<PegParEntry*> GetList() { return _list; }

    string GetFilePath();
    Parameter* GetParameter()     { return _param; }

    void ResetEntries(); 

  protected:

   string    _fname;
   string    _fpath;
   string    _lastChanges; 
   GtkWidget*  _parent; 
   GtkWidget* _layout;
   int        _parCnt;
   Parameter* _param; 
   bool       _showHidden; 

   list<PegParEntry*> _list;  // List of parameters
};

extern PegParData *thePData;

#endif

