// 
//  Copyright (C) 2002,2007,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGPARENTRYINTEGER_HH
#define PEGPARENTRYINTEGER_HH

#include <gdk/gdk.h>
#include <gtk/gtk.h>

#include "PegParEntry.hh"
#include "ParamItem.hh"

class PegParEntryInteger : public PegParEntry {

  public:

    PegParEntryInteger(ParamInteger *item);

    void set(const char* val);
    char* get();

    int getMinValue()          { return _min; }
    int getMaxValue()          { return _max; }
    int getScale()             { return _scale; }
    void setScale(int val)     { _scale = val; }
    void set_adjustments(); 

    ParamInteger* GetItem()    { return _item; }

    static int change_cb(GObject *object, gpointer user_data);
    static int ButtonPressCB(GObject *object, GdkEvent *event,
                             gpointer user_data);
    static int FocusOutCB(GObject *object, GdkEvent *event, gpointer user_data);
    static int TextEditCB(GObject *object, gpointer user_data);
    static int IndirEditCB(GObject *object, gpointer user_data);

    virtual void manage();
    virtual void set_error_color();    // set widget red to indicate err
    virtual void clear_error_color();  // clear error code

    bool check_valid_input(string val); 

    int update_indir();
    int update_text();
    bool in_edit()  { return _inedit; } 

    string get_lastval()   { return _lastval; }
    void set_lastval(string val)  { _lastval = val; }

  protected:
    virtual ~PegParEntryInteger();

  private:

   ParamInteger* _item; 
   GtkWidget* _spin_w; 
   GtkAdjustment *_adj; 
   int        _min; 
   int        _max; 
   int        _scale;   // arrow button adjustment values;
   bool       _inedit; 
   string     _lastval;
    
};

#endif

