// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "PegStatusArea.hh"

using namespace std;

PegStatusArea::PegStatusArea()
{
   base_w = gtk_scrolled_window_new(NULL, NULL);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (base_w),
                                   GTK_POLICY_ALWAYS,
                                   GTK_POLICY_ALWAYS);
   buffer = gtk_text_buffer_new(NULL);
   textBox = gtk_text_view_new_with_buffer(buffer);
   gtk_text_view_set_editable(GTK_TEXT_VIEW(textBox), false);
   gtk_container_add(GTK_CONTAINER(base_w), textBox);
   prepend = true; 
}

PegStatusArea::~PegStatusArea()
{
   
}


int PegStatusArea::add_message(string msg, int type)
{
   if (msg.length())
   {
      // add timestamp to message- although it could be done using glib's
      // time functions- use the standard c libs for now...
      static int ln;
      time_t secs;
      char tstamp[33];
      string str;
      time(&secs);
      strftime(((char*)tstamp)+1,32,"%a %d-%b %H:%M:%S ",localtime(&secs));
      str = tstamp+1;
      str.append(msg);
      str.append("\n");
      GtkTextIter iter;
      if (prepend)
         gtk_text_buffer_get_start_iter (buffer, &iter);
      else 
         gtk_text_buffer_get_iter_at_line (buffer, &iter, ln++);
      gtk_text_buffer_insert(GTK_TEXT_BUFFER(buffer), &iter, str.c_str(), -1);
   }
   return 0; 
}

int PegStatusArea::show()
{
   gtk_widget_show(base_w);
   return 0;
}
