// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMAPPENDROWCMD_HH
#define PRISMAPPENDROWCMD_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <string>

#include "PrismBaseObj.hh"

using namespace std;

class PrismDataTable;

class PrismAppendRowCmd: public PrismBaseObj
{
  public:
    PrismAppendRowCmd();
    ~PrismAppendRowCmd();
    virtual int show();

    int doit(PrismDataTable* table); 
    int set_rowscale_value(long val);
    int set_rowspin_value(long val);

    void set_sensitive(); 

    static int toggled_value_callback(GObject *object, gpointer user_data);
    static int rowscale_value_callback(GObject *object, gpointer user_data);
    static int rowspin_value_callback(GObject *object, gpointer user_data);

  protected:
    void create_dialog();
    
    PrismDataTable* _table;

    GtkWidget* _rowtog_w;
    GtkWidget* _zerotog_w;
    GtkWidget* _rowscale_w;
    GtkWidget* _rowspin_w; 

    long _rowcurr; 
    long _rowmin;
    long _rowmax; 

    int     _toggle;    // 0 = by row,  1 = null initialize 
};

#endif 
