// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMCOLUMNINFRAP_HH
#define PRISMCOLUMNINFRAP_HH

#include <string>

using namespace std;

#define PRISM_SCALAR_COL        0 
#define PRISM_ARRAY_COL         1  
#define PRISM_VECTOR_COL        2  

#define PRISM_SHORT_TYPE        0
#define PRISM_LONG_TYPE         1
#define PRISM_FLOAT_TYPE        2
#define PRISM_DOUBLE_TYPE       3 
#define PRISM_STRING_TYPE       4 
#define PRISM_UBYTE_TYPE        5
#define PRISM_ULONG_TYPE        6
#define PRISM_USHORT_TYPE       7
#define PRISM_BOOL_TYPE         8

typedef struct
{
   string   name;
   string   units;
   string   comment;
   string*  components; 
   string*  values;       // values for initialization 
   int      valcnt;       // number of value entries 
   int      ctype;
   int      dtype;
   int      asize;
   int      vsize;
   int      ssize;
   bool     copycol;      // copy values from existing column
} PrismColumnInfra_t, *PrismColumnInfra_p;


#endif 
