// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMHEADERTABLE_HH
#define PRISMHEADERTABLE_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "PrismBaseObj.hh"
#include "PrismDataSet.hh"

class PrismFileFrame; 

using namespace std;

typedef struct
{
   gchar   *name;
   gchar   *type;
   gchar   *dim; 
}
ExtnTableItem;

enum
{
   KEY_NAME,
   KEY_TYPE,
   KEY_DIM,
   NUM_COLUMNS
};



class PrismExtnTable: public PrismBaseObj
{
  public:
    PrismExtnTable(PrismFileFrame* parent);
    virtual ~PrismExtnTable();

    int load_entries(list<ExtensionInfo_t> exts, int extnum=-1);

    virtual int show(); 

  protected:
    // callbacks 
    static void select_entry(GtkWidget *widget, gpointer data);

    // class members
    PrismFileFrame* _parent;
    GtkWidget *table;
//    GArray *articles; 
    GtkListStore *model;
    GtkTreeIter iter;
    GtkTreeView *treeview;
};

#endif 
