// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMFILELIST_HH
#define PRISMFILELIST_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <map>
#include <string>

#include "PrismBaseObj.hh"

class PrismFileFrame; 

using namespace std;

class PrismFileList: public PrismBaseObj
{
  public:
    PrismFileList();
    ~PrismFileList();
    int add_file(string filename="", int new_tab=0); 
    int remove_file(string filename);
    string get_filename(int ext=-1, int filter=0); 

    int remove_tab(int val);

    int reload_tab(int ext=1, long row=1);
    int visualize_tab(int type, int dialog=1);
    int select_in_tab(int val, int as_col=1); 
    int lock_tab(int mode);
    int get_num_tabs()   { return frames.size(); } 
    int get_tab_position()  { return (int)tab_pos; } 
    int set_current_tab(int val); 
    int get_current_tab(); 
    int get_current_mode();

    // tab controls
    void rotate_tabs(int val = -1);
    void show_tabs();
    void hide_tabs();
    bool tabs_visible()  { return tabs_on; }
    void set_modified(); 

    virtual int show(); 
  protected:
    map<GtkWidget*, PrismFileFrame*>frames;
    GtkPositionType  tab_pos; 
    bool  tabs_on; 
};

#endif 
