// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMFILEMENU_HH
#define PRISMFILEMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "PrismBaseObj.hh"

#define PRSM_FLIST_SZ        10

using namespace std;

class PrismFileMenu: public PrismBaseObj 
{
  public:
    PrismFileMenu();
    virtual ~PrismFileMenu();

    static int  open_cb(GObject *object, gpointer user_data);
    static int  reopen_cb(GObject *object, gpointer user_data);
    static int  opentab_cb(GObject *object, gpointer user_data);
    static int  closetab_cb();
    static int  quit_cb();
    static int  filelist_cb(gchar* buf);
    static int  filelisttab_cb(gchar* buf);

    virtual int show();

    void        set_prev_dir(string fname)  { _prev_dir = fname; }
    const char* get_prev_dir()     { return _prev_dir.c_str(); } 
    void        load_recent_submenu(); 
    void        update_filelist(string file); 

  protected:
    GtkWidget *menu;
    GtkWidget *menuItemOpen;
    GtkWidget *menuItemReopen;
    GtkWidget *menuItemOpenTab;
    GtkWidget *menuItemCloseTab;
    GtkWidget *menuItemRecent;
    GtkWidget *menuItemRecentTab;
    GtkWidget *menuItemQuit;
    GtkWidget *_submenuRecent;      // open recent files in existing tab
    GtkWidget *_submenuRecentTab;   // open recent files in new tab 
    string    _filelist;            // name of file containing opened file list
    string    _prev_dir;            // previous directory 
    string    _listEntries[PRSM_FLIST_SZ];
    GtkWidget *_filelistItem[PRSM_FLIST_SZ];
    GtkWidget *_filelist2Item[PRSM_FLIST_SZ];
    GtkTooltips* _tips; 
};

#endif 
