// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMFORMATDIALOG_HH
#define PRISMFORMATDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>
#include <list>

#include "PrismBaseObj.hh"

class PrismDataColumn;

typedef struct 
{
   PrismDataColumn* column;
   string        info; 
   GtkWidget*    label;
   GtkWidget*    entry;
} FormatElem_t, *FormatElem_p; 

using namespace std;


class PrismFormatDialog: public PrismBaseObj
{
  public:
    PrismFormatDialog(string title, PrismDataColumn* cols, long colcnt);
    ~PrismFormatDialog();
    virtual int show();

    int doit(); 

    void set_ok_sensitive(bool val); 
    static void key_edited_callback(GObject *object, gpointer user_data);

    PrismDataColumn* get_associated_column(GtkWidget *wid); 

  protected:
    void generate_form(); 

    GtkWidget* _scrolled; 
    GtkWidget* _table; 
    list<FormatElem_p> _elems; 
    PrismDataColumn* _cols;
    long       _colcnt; 
    string     _title; 
    int        _entrycnt; 
    static GdkColor _errcolor;    // color structure for invalid backgrounds
};

#endif 
