// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMHEADERAREA_HH
#define PRISMHEADERAREA_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "PrismBaseObj.hh"

class PrismHeaderTable; 
class PrismHeaderToolBar; 
class PrismDataSet; 
class PrismHeaderAddCmd; 
class PrismHeaderDeleteCmd; 

using namespace std;

class PrismHeaderArea: public PrismBaseObj
{
  public:
    PrismHeaderArea(string filename="");
    virtual ~PrismHeaderArea();
    virtual int show(); 

    int set_data(PrismDataSet* dset);

    void add_keyword();
    void delete_keyword();

    void disable_editing();
    void enable_editing();

  protected:
    GtkWidget *vbox; 
    GtkWidget *hbox; 
    PrismHeaderToolBar* toolBar; 
    PrismHeaderTable* table; 
    PrismDataSet*    _dset;

    PrismHeaderAddCmd* _addCmd; 
    PrismHeaderDeleteCmd* _deleteCmd; 
};

#endif 
