// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMHEADERTOOLBAR_HH
#define PRISMHEADERTOOLBAR_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "PrismBaseToolBar.hh"

class PrismHeaderArea; 

using namespace std;

class PrismHeaderToolBar: public PrismBaseToolBar 
{
  public:
   PrismHeaderToolBar(PrismHeaderArea* parent);
   ~PrismHeaderToolBar();

   virtual int enable_all(int flag=0);
   virtual int disable_all();
   virtual int show(); 
   void disable_editing();
   void enable_editing();

   static void add_button_callback(GObject *object, gpointer user_data);
   static void delete_button_callback(GObject *object, gpointer user_data);


  protected:
   // Header Interaction Tool Buttons
   GtkToolItem *addBtn;
   GtkToolItem *deleteBtn;
   GtkToolItem *findBtn;
   GtkToolItem *filterBtn;
   GtkToolItem *metaBtn;

   PrismHeaderArea* _parent; 

};

#endif 
