// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMIMAGECMD_HH
#define PRISMIMAGECMD_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>
#include <list>

#include "PrismBaseObj.hh"

using namespace std;

class PrismDataSet;

class PrismImageCmd: public PrismBaseObj
{
  public:
    PrismImageCmd();
    ~PrismImageCmd();
    virtual int show();

    int doit(PrismDataSet* dset, int dialog=-1); // -1=app default, 0=no 1=yes
    int generate_image();

  protected:
    void generate_form(); 
    GtkEntry*     _entry;         // entry widget from combo pulldown 
    GtkWidget*    _launch;        // toggle option to launch ds9 
    GtkWidget*    _binx_w;        // x column to bin 
    GtkWidget*    _biny_w;        // y column to bin 
    GtkWidget*    _blockx_w;      // x bin factor 
    GtkWidget*    _blocky_w;      // y bin factor 
    GtkWidget*    _label_w[5];    // labels  
    GtkAdjustment* _adjx;         // x spin button adjustment 
    GtkAdjustment* _adjy;         // y spin button adjustment 

    PrismDataSet* _dset; 
    bool          _launched_ds9; 

    string        _xpa_name;      // access point to use for ds9 
    string        _binx;          // x column for binning 
    string        _biny;          // y column for binning 
    double        _blockx;        // x block factor
    double        _blocky;        // y block factor
    bool          _instantiate;   // launch ds9 if it doesn't exist 
    list<string>  _imagers;       // list of imagers instantiated 
    bool          _img;           // current block is an image?

};

#endif 
