// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMMETADIALOG_HH
#define PRISMMETADIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "PrismBaseObj.hh"

#define META_DIALOG_MAXSZ  12

using namespace std;

class PrismDataColumn;

class PrismMetaDialog: public PrismBaseObj
{
  public:
    PrismMetaDialog(string title, PrismDataColumn* cols, long colcnt);
    ~PrismMetaDialog();
    virtual int show();

    int doit(); 

  protected:
    void generate_form(); 

    GtkWidget* _scrolled; 
    GtkWidget* _sheet;
    PrismDataColumn* _cols;
    long       _colcnt; 
    string     _title; 
    bool       _vis[META_DIALOG_MAXSZ];
    int        _entrycnt; 

};

#endif 
