// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMSTATUSAREA_HH
#define PRISMSTATUSAREA_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "PrismBaseObj.hh"

using namespace std;

class PrismStatusArea: public PrismBaseObj
{
  public:
    PrismStatusArea();
    ~PrismStatusArea();
    int add_message(string msg, int type = 0);

    int  set_timestamp(bool val)   { timestamp = val; return 0; } 
    bool get_timestamp()           { return timestamp; } 
    int  set_message_prepend(bool val)  { prepend = val; return 0; }
    bool get_message_prepend()     { return prepend; } 
    int  get_message_count()       { return cnt; }
    string get_all_messages(); 
    void set_error_color(string val);
    void set_color(bool val)       { use_color = val; }
    void set_bold(bool val)        { use_bold = val; }
    void set_italic(bool val)      { use_italic = val; }
    virtual int show(); 

  protected: 
    GtkWidget *textBox;
    GtkTextBuffer *buffer;
    GtkTextTag *color_tag;    // tag for error color
    GtkTextTag *bold_tag;     // tag for bold weight
    GtkTextTag *italic_tag;   // tag for italic font style
    GtkTextMark *mark;        // text buffer marked position 
    string buff;              // text buffer 
    bool timestamp;           // prefix message w/ time stamp 
    bool prepend;             // new messages prepended vs appended  

    bool use_bold;            // use bold for type 1 (err) messages
    bool use_italic;          // use bold for type 1 (err) messages
    bool use_color;           // use bold for type 1 (err) messages
    string color;             // color to use for errors 
    long cnt;                 // number of messages logged 
};

#endif 
