// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//



#include "PrismTableColumn.hh"
#include "PrismDataColumn.hh"

using namespace std;

int PrismTableColumn::_index = 0; 

PrismTableColumn::PrismTableColumn(PrismDataColumn* col, long colmin, long colmax, int state)
{
   _dcol = col;
   _colmin = colmin;
   if (colmax == -1)   _colmax = colmin;
      else             _colmax = colmax;

   _state = state;
   if (!_dcol)  _err = 1;
   if (_colmin < 0)  _err = 2;
   if (_colmax < _colmin) _err = 3; 
   _togmin = _togmax = -1;
   _id = _index++; 
   _image = false; 
}

PrismTableColumn::~PrismTableColumn()
{
}

int PrismTableColumn::get_colminmax(long &tmin, long &tmax)
{
   tmin = _colmin;
   tmax = _colmax;
   return (tmin == -1 || tmax == -1); 
}

int PrismTableColumn::get_togminmax(long &tmin, long &tmax)
{
   tmin = _togmin;
   tmax = _togmax;
   return (tmin == -1 || tmax == -1); 
}




