// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "TaskmonStatusArea.hh"

using namespace std;

TaskmonStatusArea::TaskmonStatusArea()
{

  // first create a frame into which the text box will be placed and
  // etch the borders out
   base_w = gtk_frame_new(NULL);
   gtk_frame_set_shadow_type(GTK_FRAME(base_w), GTK_SHADOW_ETCHED_OUT);
   gtk_widget_set_size_request( base_w, 50, -1);

   // create the new text buffer; make it UN-EDITABLE; and add it
   // to the frame
   buffer = gtk_text_buffer_new(NULL);
   textBox = gtk_text_view_new_with_buffer(buffer);
   gtk_text_view_set_editable(GTK_TEXT_VIEW(textBox), false);
   gtk_container_add(GTK_CONTAINER(base_w), textBox);
   prepend = true; 
}

TaskmonStatusArea::~TaskmonStatusArea()
{
   
}


int TaskmonStatusArea::add_message(string msg, int type)
{
   if (msg.length())
   {
    GtkTextIter iter, enditer;

    // tack on a CRLF
      msg.append("\n");

      // Get the starting and ending locations of any string 
      // already present in the text buffer
      gtk_text_buffer_get_start_iter (buffer, &iter);
      gtk_text_buffer_get_end_iter(buffer, &enditer);

      // Delete any string that happens to already be there
      gtk_text_buffer_delete(buffer, &iter, &enditer);

      // Write the new string out to the text buffer
      gtk_text_buffer_insert(GTK_TEXT_BUFFER(buffer), &iter, msg.c_str(), -1);
   }
   return 0; 
}

int TaskmonStatusArea::show()
{
   gtk_widget_show(base_w);
   return 0;
}
