// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef TASKMONSTATUSAREA_HH
#define TASKMONSTATUSAREA_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

using namespace std;

class TaskmonStatusArea
{
  public:
    TaskmonStatusArea();
    ~TaskmonStatusArea();
    int add_message(string msg, int type = 0);

    int  set_timestamp(bool val)   { timestamp = val; return 0; } 
    bool get_timestamp()           { return timestamp; } 
    int  set_message_prepend(bool val)  { prepend = val; return 0; }
    bool get_message_prepend()     { return prepend; } 

    int show(); 

    GtkWidget* base_widget()       { return base_w; }

  protected: 
    GtkWidget*     base_w; 
    GtkWidget*     textBox;
    GtkTextBuffer* buffer;
    bool           timestamp; 
    bool           prepend; 
};

extern TaskmonStatusArea *_status_area;

#endif 
