// 
//  Copyright (C) 1998,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CIAOGUIIPCSERVER_HH
#define CIAOGUIIPCSERVER_HH

#include "CiaoGuiIPCComm.hh"

#include <list>
#include <string>

using namespace std; 


// The Interprocess Communication Server Class
class CiaoGuiIPCServer : public CiaoGuiIPCComm 
{
   public:
      CiaoGuiIPCServer(char* pname, int initialize=1);
      virtual ~CiaoGuiIPCServer();

      static int   receiveCallback(void*, void*, char*, char*, int);
      static int   sendCallback(void*, void*, char*, char**, int*);

      int AddCallback(char *name, 
                      CiaoGuiIPCMessage* (*appcb)(CiaoGuiIPCMessage&),
                      string doc_comment = "");

      static CiaoGuiIPCMessage* exitMsgCB(CiaoGuiIPCMessage&);

      virtual void    Exit() { exit(0); }

      void    InitializeServer(char* nam=NULL); 
      void    SetupServer(const char* classnam, const char* nam); 
      void    GtkLoopAdd();

   protected:

      CiaoGuiIPCMessage  *DoCallback(CiaoGuiIPCMessage&);
      static CiaoGuiIPCCallbackTablePtr  cbTable;

   private:
      void  Init();
      CiaoGuiIPCMessage* CmdOptions();

      string          _accessName;
      list<string>    _optList;        // list of comments for access points 
      int             _useDefaultName; // 1 = use default access name
      static int      _refcount;   
      static int      _initialized;   

};


#endif
