// 
//  Copyright (C) 2002,2007,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGPARENTRYBOOLEAN_HH
#define PEGPARENTRYBOOLEAN_HH

#include "PegParEntry.hh"
#include "ParamItem.hh"


class PegParEntryBoolean : public PegParEntry {

  public:

    PegParEntryBoolean(ParamBoolean *item);

    void set(const char* val);
    char* get();

    string GetPrevState()       { return _prevState; } 
    int ToggleState()          { return (_toggle = (_toggle == 0)); } 

    ParamBoolean* GetItem()    { return _item; }


    static int FocusOutCB(GObject *object, GdkEvent *event, gpointer user_data);
    static int IndirEditCB(GObject *object, gpointer user_data);
    static int ToggleChangeCB(GObject *object, gpointer user_data);

    virtual void manage();
    virtual void set_error_color();    // set widget red to indicate err
    virtual void clear_error_color();  // clear error code

    int update_indir();

  protected:
    virtual ~PegParEntryBoolean();

  private:

   ParamBoolean* _item; 
   GtkWidget*    _yes_btn;  
   GtkWidget*    _no_btn;  

   int           _toggle;     // tracks setting/unsetting toggle events 
   string        _prevState;  // last setting of the parameter  

};

#endif

