// 
//  Copyright (C) 2002,2007,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGPARENTRYSTRING_HH
#define PEGPARENTRYSTRING_HH

#include <gdk/gdk.h>
#include <gtk/gtk.h>

#include "PegParEntry.hh"
#include "ParamItem.hh"

class PegParEntryString : public PegParEntry {

  public:

    PegParEntryString(ParamString *item);

    void set(const char* val);
    void set_text_field(char* val); 
    char* get();

    ParamString* GetItem()    {return _item;}
    static int FocusOutCB(GObject *object, GdkEvent *event, gpointer user_data);
    static int TextEditCB(GObject *object, gpointer user_data);
    static int IndirEditCB(GObject *object, gpointer user_data);
    static int BrowseButtonCB(GObject *object, gpointer user_data);

    virtual void manage(); 
    virtual void set_error_color();    // set widget red to indicate err
    virtual void clear_error_color();  // clear error code

    int update_indir(); 
    int update_text(); 

    void        set_prev_dir(string fname)  { _prev_dir = fname; }
    const char* get_prev_dir()     { return _prev_dir.c_str(); }

  protected:
    ~PegParEntryString();

  private:
    static string _prev_dir;           // previous directory for browse
    ParamString*  _item; 
    GtkWidget*    _browse; 
};

#endif

